/*-------------------------Copyright Notice ---------------------------------
                 Copyright (c) 1996  NETBULA, LLC
                    All Rights Reserved

This generated text is a part of the source code of a computer software.
It contains proprietary information and trade secrets of NETBULA, LLC.
No part of this copyrighted work may be reproduced or disclosed by any
means without the prior written permission from the copyright owner.

No part of this source code nor its compiled form may be used in a commercial
software unless authorized by a license agreement between you and the copyright
owner, Netbula, LLC.

Netbula, LLC is not liable under any theory for any direct or indirect damage
resulted from using this generated source code.

For license information, please contact Netbula at:
Netbula, LLC  P.O. Box 99335 Emeryville CA 94662 USA
----------------------------------------------------------------------------*/
#define POWERRPC_XDR
#define POWERRPC_CLIENT
#include "ta.h"
static char *version_str="@(#)powerRPC V1.1 MxTF! system: Linux";
;
CLIENT* TA_2_handle = 0;
struct timeval TA_2_timeout = {60, 0};
int	send_array_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct send_array_in_t* pIn){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     SEND_ARRAY,
	                     (xdrproc_t)xdr_send_array_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_void,
	                     (void*)0,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
#if PW_NO_SUPRESS_CLNT_ERROR
		clnt_perror(pclnt,"send_array");
#endif
	}
	return ret_code;
}

void	send_array(vararray	twod){
	send_array_in_t	Input;

	struct timeval timeOut;
	Input.twod = twod;

	timeOut = TA_2_TIMEOUT;
	send_array_wrap(TA_2_HANDLE, &timeOut, &Input);

}

int	get_array_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct get_array_out_t* pOut){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     GET_ARRAY,
	                     (xdrproc_t)xdr_void,
	                     (void*)0,
	                     (xdrproc_t)xdr_get_array_out_t,
	                     (void*)pOut,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
#if PW_NO_SUPRESS_CLNT_ERROR
		clnt_perror(pclnt,"get_array");
#endif
	}
	return ret_code;
}

void	get_array(vararray*	twod){
	get_array_out_t	Output;

	struct timeval timeOut;
	memset(&Output, 0, sizeof(Output));
	Output.twod = twod;

	timeOut = TA_2_TIMEOUT;
	get_array_wrap(TA_2_HANDLE, &timeOut,	&Output);

}

int	send_varray_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct send_varray_in_t* pIn){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     SEND_VARRAY,
	                     (xdrproc_t)xdr_send_varray_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_void,
	                     (void*)0,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
#if PW_NO_SUPRESS_CLNT_ERROR
		clnt_perror(pclnt,"send_varray");
#endif
	}
	return ret_code;
}

void	send_varray(varintarr	varr){
	send_varray_in_t	Input;

	struct timeval timeOut;
	Input.varr = varr;

	timeOut = TA_2_TIMEOUT;
	send_varray_wrap(TA_2_HANDLE, &timeOut, &Input);

}

int	send_v2_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct send_v2_in_t* pIn){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     SEND_V2,
	                     (xdrproc_t)xdr_send_v2_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_void,
	                     (void*)0,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
#if PW_NO_SUPRESS_CLNT_ERROR
		clnt_perror(pclnt,"send_v2");
#endif
	}
	return ret_code;
}

void	send_v2(int*	varr, int	len){
	send_v2_in_t	Input;

	struct timeval timeOut;
	Input.varr = varr;
	Input.len = len;

	timeOut = TA_2_TIMEOUT;
	send_v2_wrap(TA_2_HANDLE, &timeOut, &Input);

}

CLIENT*	ta_bind(const char* host, u_long prog, u_long ver,char* proto) {
	char * protoc = "tcp";
	ver = (ver==0? TA_2 : ver);
	prog = (prog==0? TA : prog );
	protoc = (proto==(char*)0? protoc : proto);
	TA_2_handle = clnt_create(host, prog, ver, protoc);
	return TA_2_handle;
}

void	ta_bind_handle(CLIENT* pclnt){
	TA_2_handle = pclnt;
}

void	ta_unbind(CLIENT* pclnt) {
	pclnt  = (pclnt==0? TA_2_handle: pclnt);
	if(pclnt)
		clnt_destroy(pclnt);
}

enum clnt_stat	ta_errno(CLIENT* pclnt) {
	return pw_clnt_errno(pclnt?pclnt:TA_2_HANDLE);
}

