#include "talk2.h"
#include <stdio.h>
#include <unistd.h>
#include <signal.h>

/* This is the function to be called on the server,
   since our talk program is both a TALK server and a TALK client,
   we need to add a prefix to the rpc function name for the server.
*/

void            s_send_msg(unsigned long sno,
                           char *host, char *sender, char *msg)
{
    printf("\n.............................%s@%d@%s...........................\n%s",
	       sender, sno, host,  msg);
    printf("..................................over...............................\n");
    talk2_unbind(0);
    talk2_bind(host, sno, 0, 0);
}

char            peer_host[1024] = "";
char            myname[256] = "anonymous";
char            myhost[1024];
unsigned long   myprog = 0;
unsigned long   peer_no =0;
SVCXPRT        *transp=0;

void unset_myprog(int sig) {
		talk2_1_unmap(myprog,1);
		exit(0);
}


void            getoption(int argc, char **argv)
{
    int             c;
    extern char    *optarg;
    while ((c = getopt(argc, argv, "n:p:c:P:")) > 0) {
        switch (c) {
        case 'n':
            strcpy(myname, optarg);
            break;
        case 'p':
            myprog = atol(optarg);
            break;
        case 'c':
            strcpy(peer_host, optarg);
            break;
		case 'P':
            peer_no = atol(optarg);
            break;

        }
    }
}

void handle_stdin(int fd) {
		char msg[1024];
		int cnt;
		if(fd!=0) {
				printf("Something went wrong, you must use fd == 0.\n");
				return ;
		}
		cnt = read(fd, msg, 1023);
		if(cnt <= 0) exit(1);

		msg[cnt]='\0';
#if 0
		printf("from %s sending to %s...\n", myhost, peer_host);
		printf("%s %s\n",myname, msg);
#endif
        send_msg(myprog, myhost, myname, msg);
}


int             main(int argc, char **argv)
{
    fd_set          fds;
    SVCXPRT        *mytxp;
    int             serv_sock;
    int             dtsz;
    char            msg[4096];

    if (argc < 2) {
        printf("Usage: %s -n talker -p program# [-c peer -P perr_prog#]\n", argv[0]);
        exit(0);
    }
    getoption( argc, argv);

    gethostname(myhost, 1023);
	printf(myhost);

    if (strlen(peer_host)) {
        if (!talk2_bind(peer_host, peer_no, 0, 0)) {
            printf("Can not find peer to talk.\n");
            exit(1);
        }
    }

	pw_serv_init();

	myprog = myprog==0? TALK2: myprog;

    if(!talk2_1_reg(RPC_ANYSOCK, myprog, 1, IPPROTO_UDP))
        exit(1);


	printf("My program number is %d\n", myprog);
	signal(SIGINT, unset_myprog);

	pw_serv_input_handler(0, handle_stdin);

	pw_serv_mainloop(0, 0, 0, 0);


}
