
#include "tree.h"

void print_tree(struct t_node * root) {
		if(!root) return;
		printf("%s\n", root->val);
		print_tree(root->left); 
		print_tree(root->right); 
}

/* build a tree  like this 
                9
		     10    8
		   11  9  9 7

*/
                

void  maketree(struct t_node * root, int depth, int topval) {
		char buf[16];
		sprintf(buf, "%d", topval);
		root->val = malloc(strlen(buf)+1);
		strcpy(root->val, buf);
		if(depth==0) {
			root->left = 0;
			root->right = 0;
			return;
		}
		root->left = (struct t_node*) malloc(sizeof(*root));
		root->right = (struct t_node*) malloc(sizeof(*root));
		maketree(root->left, depth-1, topval+1);
		maketree(root->right, depth-1, topval-1);
}

/* free the memory, we don't free the root itself */

void freetree(struct t_node *root) {
		if(root->left){
				freetree(root->left);
				free(root->left);
		}
		if(root->right){
				freetree(root->right);
				free(root->right);
		}
		free(root->val);
}
		



